diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
index 0dc6dce..a7a240a 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.hxx
@@ -17,20 +17,17 @@
 #ifndef _BRepTopAdaptor_FClass2d_HeaderFile
 #define _BRepTopAdaptor_FClass2d_HeaderFile
 
-#include <Standard.hxx>
-#include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
-
-#include <BRepTopAdaptor_SeqOfPtr.hxx>
-#include <TColStd_SequenceOfInteger.hxx>
-#include <Standard_Real.hxx>
+#include <BRepClass_FaceClassifier.hxx>
+#include <NCollection_Sequence.hxx>
 #include <TopoDS_Face.hxx>
-#include <TopAbs_State.hxx>
-#include <Standard_Boolean.hxx>
-class TopoDS_Face;
-class gp_Pnt2d;
-
+class CSLib_Class2d;
 
+//! Checks the position of some 2D-point relatively 
+//! to the face.
+//! Returns status ON if the point is in the at least of one
+//! edge of the face.
+//! Returns status IN if the point is included to the face.
+//! Otherwise, returns status OUT.
 
 class BRepTopAdaptor_FClass2d 
 {
@@ -38,55 +35,66 @@ public:
 
   DEFINE_STANDARD_ALLOC
 
+  //! Empty constructor
+  Standard_EXPORT BRepTopAdaptor_FClass2d();
+
+  //! Constructs algorithm by theFace and the 3D-tolerance <theTol3D>
+  Standard_EXPORT BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace,
+                                          const Standard_Real theTol3D);
   
-  Standard_EXPORT BRepTopAdaptor_FClass2d(const TopoDS_Face& F, const Standard_Real Tol);
-  
+  //! Initializes algorithm by theFace and the 3D-tolerance <theTol3D>
+  Standard_EXPORT void Init(const TopoDS_Face& theFace,
+                            const Standard_Real theTol3D);
+
+  //! Classifies an infinite 2d point relatively of the Face.
   Standard_EXPORT TopAbs_State PerformInfinitePoint() const;
   
-  Standard_EXPORT TopAbs_State Perform (const gp_Pnt2d& Puv, const Standard_Boolean RecadreOnPeriodic = Standard_True) const;
+  //! Returns state of the 2d point theP2D.
+  //! If theIsReqToAdjust==TRUE the point will be adjusted
+  //! to period for a periodical surface before classification.
+  Standard_EXPORT TopAbs_State
+    Perform(const gp_Pnt2d& theP2D,
+            const Standard_Boolean theIsReqToAdjust = Standard_True) const;
   
+  //! Destructor
   Standard_EXPORT void Destroy();
-~BRepTopAdaptor_FClass2d()
-{
-  Destroy();
-}
-  
-  Standard_EXPORT const BRepTopAdaptor_FClass2d& Copy (const BRepTopAdaptor_FClass2d& Other) const;
-const BRepTopAdaptor_FClass2d& operator= (const BRepTopAdaptor_FClass2d& Other) const
-{
-  return Copy(Other);
-}
+  ~BRepTopAdaptor_FClass2d()
+  {
+    Destroy();
+  }
   
-  //! Test a point with +- an offset (Tol) and returns
-  //! On if some points are OUT an some are IN
-  //! (Caution: Internal use . see the code for more details)
-  Standard_EXPORT TopAbs_State TestOnRestriction (const gp_Pnt2d& Puv, const Standard_Real Tol, const Standard_Boolean RecadreOnPeriodic = Standard_True) const;
-
-
+  //! Classifies theP2D using 3D-tolerance theTol3D.
+  //! If theIsReqToAdjust==TRUE the point will be adjusted
+  //! to period for a periodical surface before classification.
+  Standard_EXPORT TopAbs_State
+    TestOnRestriction(const gp_Pnt2d& theP2D,
+                      const Standard_Real theTol3D,
+                      const Standard_Boolean theIsReqToAdjust = Standard_True) const;
+
+  //! Returns TRUE if material of the Face
+  //! outside of its outer wire. 
+  Standard_Boolean IsHole() const
+  {
+    return (PerformInfinitePoint() == TopAbs_IN);
+  }
 
 
 protected:
-
+  const BRepTopAdaptor_FClass2d& operator= (const BRepTopAdaptor_FClass2d&) const;
 
 
 
 
 private:
-
-
-
-  BRepTopAdaptor_SeqOfPtr TabClass;
-  TColStd_SequenceOfInteger TabOrien;
-  Standard_Real Toluv;
-  TopoDS_Face Face;
-  Standard_Real U1;
-  Standard_Real V1;
-  Standard_Real U2;
-  Standard_Real V2;
-  Standard_Real Umin;
-  Standard_Real Umax;
-  Standard_Real Vmin;
-  Standard_Real Vmax;
+  mutable BRepClass_FaceClassifier myClassifier;
+  NCollection_Sequence<CSLib_Class2d*> myTabClass;
+  NCollection_Sequence<Standard_Integer> myTabOrien;
+  TopoDS_Face myFace;
+  Standard_Real myTol3D;
+  Standard_Real myUmin;
+  Standard_Real myVmin;
+  Standard_Real myUmax;
+  Standard_Real myVmax;
 
 
 };
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_Tool.cxx b/src/BRepTopAdaptor/BRepTopAdaptor_Tool.cxx
index 80b7d14..0c0c82c 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_Tool.cxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_Tool.cxx
@@ -96,9 +96,6 @@ void BRepTopAdaptor_Tool::SetTopolTool(const Handle(BRepTopAdaptor_TopolTool)& T
 }
 
 void BRepTopAdaptor_Tool::Destroy() { 
-  int i;
-  i=0;
-  i++;
   
 }
 
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
index 0b608df..121bcb2 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.cxx
@@ -84,7 +84,7 @@ static
   s_wnt.Orientation(TopAbs_FORWARD);
   myFace = TopoDS::Face(s_wnt);
   if(myFClass2d != NULL) { 
-    delete (BRepTopAdaptor_FClass2d *)myFClass2d;
+    delete myFClass2d;
   } 
   myFClass2d = NULL;
   myNbSamplesU=-1;
@@ -188,30 +188,33 @@ static
 //function : Classify
 //purpose  : 
 //=======================================================================
-  TopAbs_State BRepTopAdaptor_TopolTool::Classify(const gp_Pnt2d& P,
-						  const Standard_Real Tol,
-						  const Standard_Boolean RecadreOnPeriodic)
+TopAbs_State BRepTopAdaptor_TopolTool::Classify(const gp_Pnt2d& P,
+                                                const Standard_Real theTol3D,
+                                                const Standard_Boolean theIsReqToAdjust)
 {
   if(myFace.IsNull())
     return TopAbs_UNKNOWN;
   if(myFClass2d == NULL) { 
-    myFClass2d = (void *) new BRepTopAdaptor_FClass2d(myFace,Tol);
+    myFClass2d = new BRepTopAdaptor_FClass2d(myFace, theTol3D);
   } 
-  return(((BRepTopAdaptor_FClass2d *)myFClass2d)->Perform(P,RecadreOnPeriodic));
+
+  const TopAbs_State aState = (myFClass2d->Perform(P,theIsReqToAdjust));
+  return aState;
 }
 
 //=======================================================================
 //function : IsThePointOn
 //purpose  : 
 //=======================================================================
-  Standard_Boolean BRepTopAdaptor_TopolTool::IsThePointOn(const gp_Pnt2d& P,
-							  const Standard_Real Tol,
-							  const Standard_Boolean RecadreOnPeriodic)
+Standard_Boolean
+    BRepTopAdaptor_TopolTool::IsThePointOn(const gp_Pnt2d& P,
+                                           const Standard_Real theTol3D,
+                                           const Standard_Boolean theIsReqToAdjust)
 {
   if(myFClass2d == NULL) { 
-    myFClass2d = (void *) new BRepTopAdaptor_FClass2d(myFace,Tol);
+    myFClass2d = new BRepTopAdaptor_FClass2d(myFace, theTol3D);
   } 
-  return(TopAbs_ON==((BRepTopAdaptor_FClass2d *)myFClass2d)->TestOnRestriction(P,Tol,RecadreOnPeriodic));
+  return(TopAbs_ON == myFClass2d->TestOnRestriction(P, theTol3D, theIsReqToAdjust));
 }
 
 //=======================================================================
@@ -221,7 +224,7 @@ static
   void BRepTopAdaptor_TopolTool::Destroy() 
 { 
   if(myFClass2d != NULL) { 
-    delete (BRepTopAdaptor_FClass2d *)myFClass2d;
+    delete myFClass2d;
     myFClass2d=NULL;
   }
 }
diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
index e95e588..592295c 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_TopolTool.hxx
@@ -32,6 +32,7 @@
 #include <TopAbs_Orientation.hxx>
 #include <Standard_Integer.hxx>
 class BRepAdaptor_HCurve2d;
+class BRepTopAdaptor_FClass2d;
 class Standard_DomainError;
 class Adaptor3d_HSurface;
 class Adaptor2d_HCurve2d;
@@ -78,10 +79,25 @@ public:
   
   Standard_EXPORT virtual void NextVertex() Standard_OVERRIDE;
   
-  Standard_EXPORT virtual TopAbs_State Classify (const gp_Pnt2d& P2d, const Standard_Real Tol, const Standard_Boolean RecadreOnPeriodic = Standard_True) Standard_OVERRIDE;
-  
-  //! see the code for specifications)
-  Standard_EXPORT virtual Standard_Boolean IsThePointOn (const gp_Pnt2d& P2d, const Standard_Real Tol, const Standard_Boolean RecadreOnPeriodic = Standard_True) Standard_OVERRIDE;
+  //! Classifies theP2d relatively to the domain of myS.
+  //! theTol3D is the 3D-tolerance (is used for check ON-status).
+  //! If theIsReqToAdjust == TRUE then the coordinates of theP2d
+  //! will be inscribed (if it is possible) in the UV-bounds of myFace.
+  Standard_EXPORT virtual
+      TopAbs_State Classify(const gp_Pnt2d& theP2d, 
+                            const Standard_Real theTol3D,
+                            const Standard_Boolean theIsReqToAdjust = 
+                                                      Standard_True) Standard_OVERRIDE;
+  
+  //! Returns TRUE if theP is in the some edge of myFace with given
+  //! 3D-tolerance theTol3D.
+  //! If theIsReqToAdjust == TRUE then the coordinates of theP2d
+  //! will be inscribed (if it is possible) in the UV-bounds of myFace.
+  Standard_EXPORT virtual Standard_Boolean
+          IsThePointOn(const gp_Pnt2d& P2d,
+                       const Standard_Real theTol3D,
+                       const Standard_Boolean 
+                                theIsReqToAdjust = Standard_True) Standard_OVERRIDE;
   
   //! If the function returns the orientation of the arc.
   //! If the orientation is FORWARD or REVERSED, the arc is
@@ -131,7 +147,11 @@ public:
   
   Standard_EXPORT virtual Standard_Boolean DomainIsInfinite() Standard_OVERRIDE;
 
-
+  //! Returns face
+  const TopoDS_Face& GetFace() const
+  {
+    return myFace;
+  }
 
   DEFINE_STANDARD_RTTIEXT(BRepTopAdaptor_TopolTool,Adaptor3d_TopolTool)
 
@@ -145,7 +165,7 @@ private:
 
   TopExp_Explorer myVIterator;
   TopoDS_Face myFace;
-  Standard_Address myFClass2d;
+  BRepTopAdaptor_FClass2d *myFClass2d;
   Handle(BRepAdaptor_HCurve2d) myCurve;
   TColStd_ListOfTransient myCurves;
   TColStd_ListIteratorOfListOfTransient myCIterator;
diff --git a/src/Blend/Blend_CSWalking_1.gxx b/src/Blend/Blend_CSWalking_1.gxx
index e86ee57..2d132ca 100644
--- a/src/Blend/Blend_CSWalking_1.gxx
+++ b/src/Blend/Blend_CSWalking_1.gxx
@@ -18,7 +18,7 @@ Blend_CSWalking::Blend_CSWalking(const TheCurve& Curv,
        done(Standard_False),surf(Surf),
        curv(Curv)
 {
-  domain = Domain;
+  myDomain = Domain;
 }
 
 
@@ -30,7 +30,7 @@ void Blend_CSWalking::Perform(Blend_CSFunction& Func,
 			      const Standard_Real MaxStep,
 			      const Standard_Real TolGuide,
 			      const math_Vector& ParDep,
-			      const Standard_Real Tolesp,
+			      const Standard_Real the3DTolEsp,
 			      const Standard_Real Fleche,
 			      const Standard_Boolean Appro)
 {
@@ -40,7 +40,7 @@ void Blend_CSWalking::Perform(Blend_CSFunction& Func,
   comptra = Standard_False;
   line = new TheLine ();
   Standard_Integer Nbvar = Func.NbVariables();
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
   fleche = Abs(Fleche);
   rebrou = Standard_False;
@@ -67,10 +67,10 @@ void Blend_CSWalking::Perform(Blend_CSFunction& Func,
 
     TopAbs_State situ;
 //    math_Vector tolerance(1,3),infbound(1,3),supbound(1,3);
-    math_Vector tolerance(1,Nbvar),infbound(1,Nbvar),supbound(1,Nbvar);
-    Func.GetTolerance(tolerance,tolesp);
+    math_Vector aVTol2D(1,Nbvar),infbound(1,Nbvar),supbound(1,Nbvar);
+    Func.GetTolerance(aVTol2D, my3DTolEsp);
     Func.GetBounds(infbound,supbound);
-    math_FunctionSetRoot rsnld(Func,tolerance,30);
+    math_FunctionSetRoot rsnld(Func,aVTol2D,30);
 
     rsnld.Perform(Func,ParDep,infbound,supbound);
     
@@ -79,16 +79,7 @@ void Blend_CSWalking::Perform(Blend_CSFunction& Func,
     }
     rsnld.Root(sol);
 
-//    situ1 = TheTopolTool::Classify(surf1,gp_Pnt2d(sol(1),sol(2)),
-//				   Max(tolerance(1),tolerance(2)));
-//    situ2 = TheTopolTool::Classify(surf2,gp_Pnt2d(sol(3),sol(4)),
-//				   Max(tolerance(3),tolerance(4)));
-/*
-    situ = domain->Classify(gp_Pnt2d(sol(1),sol(2)),
-			      Min(tolerance(1),tolerance(2)));
-*/
-    situ = domain->Classify(Func.Pnt2d(),
-			    Min(tolerance(1),tolerance(2)));
+    situ = myDomain->Classify(Func.Pnt2d(), my3DTolEsp);
 
     if (situ != TopAbs_IN ) {
       return;
@@ -115,8 +106,8 @@ void Blend_CSWalking::Perform(Blend_CSFunction& Func,
   Standard_Real U,V,W;
   previousP.ParametersOnS(U,V);
   W = previousP.ParameterOnC();
-  TheExtremity P1(previousP.PointOnS(),U,V,previousP.Parameter(),tolesp);
-  TheExtremity P2(previousP.PointOnC(),W,previousP.Parameter(),tolesp);
+  TheExtremity P1(previousP.PointOnS(), U, V, previousP.Parameter(), my3DTolEsp);
+  TheExtremity P2(previousP.PointOnC(), W, previousP.Parameter(), my3DTolEsp);
   if (sens>0.) {
     line->SetStartPoints(P1,P2);
   }
diff --git a/src/Blend/Blend_CSWalking_2.gxx b/src/Blend/Blend_CSWalking_2.gxx
index fba4785..3f8574a 100644
--- a/src/Blend/Blend_CSWalking_2.gxx
+++ b/src/Blend/Blend_CSWalking_2.gxx
@@ -39,7 +39,7 @@ Blend_Status Blend_CSWalking::TestArret(Blend_CSFunction& Function,
   Blend_Status State1,State2;
   IntSurf_TypeTrans tras = IntSurf_Undecided;
 
-  if (Function.IsSolution(Sol,tolesp)) {
+  if (Function.IsSolution(Sol, my3DTolEsp)) {
 
     pt1  = Function.PointOnS();
     pt2  = Function.PointOnC();
@@ -176,15 +176,15 @@ Blend_Status Blend_CSWalking::CheckDeflectionOnSurf
 
   prevP = previousP.PointOnS();
   prevTg = previousP.TangentOnS();
-  tolu = TheSurfaceTool::UResolution(surf,tolesp);
-  tolv = TheSurfaceTool::VResolution(surf,tolesp);
+  tolu = TheSurfaceTool::UResolution(surf, my3DTolEsp);
+  tolv = TheSurfaceTool::VResolution(surf, my3DTolEsp);
 
   gp_Vec Corde(prevP,Psurf);
   Norme = Corde.SquareMagnitude();
   prevNorme = prevTg.SquareMagnitude(); // JAG MODIF 25.04.94
 
 
-  if (Norme <= tolesp*tolesp || prevNorme <= tolesp*tolesp) { // JAG MODIF 25.04.94
+  if (Norme <= my3DTolEsp*my3DTolEsp || prevNorme <= my3DTolEsp*my3DTolEsp) { // JAG MODIF 25.04.94
     // il faudra peut etre  forcer meme point  JAG MODIF 25.04.94
     return Blend_SamePoints;
   }
@@ -275,7 +275,7 @@ Blend_Status Blend_CSWalking::CheckDeflectionOnCurv
 
   prevP = previousP.PointOnC();
   prevTg = previousP.TangentOnC();
-  tolu = TheCurveTool::Resolution(curv,tolesp);
+  tolu = TheCurveTool::Resolution(curv, my3DTolEsp);
 
   gp_Vec Corde(prevP,Pcurv);
   Norme = Corde.SquareMagnitude();
@@ -283,11 +283,11 @@ Blend_Status Blend_CSWalking::CheckDeflectionOnCurv
 
 
 // if (Norme <= tolesp*tolesp || prevNorme <= tolesp*tolesp) { // JAG MODIF 25.04.94
-  if (Norme <= tolesp*tolesp) { // le 95.01.10
+  if (Norme <= my3DTolEsp*my3DTolEsp) { // le 95.01.10
     // il faudra peut etre  forcer meme point  JAG MODIF 25.04.94
     return Blend_SamePoints;
   }
-  else if (prevNorme > tolesp*tolesp) {
+  else if (prevNorme > my3DTolEsp*my3DTolEsp) {
     Cosi = sens*Corde*prevTg;
     if (Cosi <0.) { // angle 3d>pi/2. --> retour arriere
       return Blend_Backward;
@@ -308,7 +308,7 @@ Blend_Status Blend_CSWalking::CheckDeflectionOnCurv
 
   // Voir s il faut faire le controle sur le signe de prevtg*Tgsurf
 
-  if (Tgcurv.Magnitude() <= tolesp) {
+  if (Tgcurv.SquareMagnitude() <= my3DTolEsp*my3DTolEsp) {
     return Blend_SamePoints; // GROS BOBARD EN ATTENDANT
   }
 
@@ -318,7 +318,7 @@ Blend_Status Blend_CSWalking::CheckDeflectionOnCurv
     return Blend_StepTooLarge;
   }
 
-  if (prevNorme > tolesp*tolesp) {
+  if (prevNorme > my3DTolEsp*my3DTolEsp) {
 
     // Estimation de la fleche courante
 /*    
diff --git a/src/Blend/Blend_CSWalking_3.gxx b/src/Blend/Blend_CSWalking_3.gxx
index 5f623b8..291aad2 100644
--- a/src/Blend/Blend_CSWalking_3.gxx
+++ b/src/Blend/Blend_CSWalking_3.gxx
@@ -205,8 +205,8 @@ void Blend_CSWalking::MakeExtremity(TheExtremity& Extrem,
 
 //  Extrem.SetValue(previousP.PointOnS(),sol(1),sol(2),tolesp);
   previousP.ParametersOnS(U,V);
-  Extrem.SetValue(previousP.PointOnS(),U,V,previousP.Parameter(),tolesp);
-  Iter = domain;
+  Extrem.SetValue(previousP.PointOnS(), U, V, previousP.Parameter(), my3DTolEsp);
+  Iter = myDomain;
 
 
   Iter->Init();
diff --git a/src/Blend/Blend_CSWalking_4.gxx b/src/Blend/Blend_CSWalking_4.gxx
index ce7ed90..7598972 100644
--- a/src/Blend/Blend_CSWalking_4.gxx
+++ b/src/Blend/Blend_CSWalking_4.gxx
@@ -32,7 +32,7 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
   gp_Pnt2d p2d;
 //  math_Vector tolerance(1,3),infbound(1,3),supbound(1,3),parinit(1,3);
 //  math_Vector solrst(1,3);
-  math_Vector tolerance(1,Nbvar),infbound(1,Nbvar),supbound(1,Nbvar),
+  math_Vector aVTol2D(1,Nbvar),infbound(1,Nbvar),supbound(1,Nbvar),
               parinit(1,Nbvar);
   math_Vector solrst(1,Nbvar);
   TheVertex Vtx;
@@ -40,10 +40,10 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 
   //IntSurf_Transition Tline,Tarc;
 
-  Func.GetTolerance(tolerance,tolesp);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   Func.GetBounds(infbound,supbound);
 
-  math_FunctionSetRoot rsnld(Func,tolerance,30);
+  math_FunctionSetRoot rsnld(Func,aVTol2D,30);
   parinit = sol;
 
   param = parprec + sens*stepw;
@@ -64,16 +64,7 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
     else {
       rsnld.Root(sol);
 
-//      situ1 = TheTopolTool::Classify(surf1,gp_Pnt2d(sol(1),sol(2)),
-//				     Max(tolerance(1),tolerance(2)));
-//      situ2 = TheTopolTool::Classify(surf2,gp_Pnt2d(sol(3),sol(4)),
-//				     Max(tolerance(3),tolerance(4)));
-/*
-      situ = domain->Classify(gp_Pnt2d(sol(1),sol(2)),
-			      Min(tolerance(1),tolerance(2)));
-*/
-      situ = domain->Classify(Func.Pnt2d(),
-			      Min(tolerance(1),tolerance(2)));
+      situ = myDomain->Classify(Func.Pnt2d(), my3DTolEsp);
 
       w = Bound;
       recad = Standard_False;
@@ -96,13 +87,13 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 	  // sol sur surf
 	  State = Blend_OnRst1;
 	  param = w;
-	  domain->Init();
+	  myDomain->Init();
 	  nbarc = 1;
 	  while (nbarc < Index) {
 	    nbarc++;
-	    domain->Next();
+	    myDomain->Next();
 	  }
-	  p2d = TheArcTool::Value(domain->Value(),solrst(1));
+	  p2d = TheArcTool::Value(myDomain->Value(),solrst(1));
 	  sol(1) = p2d.X();
 	  sol(2) = p2d.Y();
 	  sol(3) = solrst(3);
@@ -146,9 +137,9 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 */
 	  previousP.ParametersOnS(U,V);
 	  Exts.SetValue(previousP.PointOnS(),U,V, 
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  Extc.SetValue(previousP.PointOnC(),previousP.ParameterOnC(),
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  // Indiquer que fin sur Bound.
 	}
 	else {
@@ -171,9 +162,9 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 */
 	  previousP.ParametersOnS(U,V);
 	  Exts.SetValue(previousP.PointOnS(),U,V,
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  Extc.SetValue(previousP.PointOnC(),previousP.ParameterOnC(),
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  Arrive = Standard_True;
 	  if (line->NbPoints()>=2) {
 	    // Indiquer qu on s arrete en cours de cheminement
@@ -214,9 +205,9 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 */
 	  previousP.ParametersOnS(U,V);
 	  Exts.SetValue(previousP.PointOnS(),U,V,
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  Extc.SetValue(previousP.PointOnC(),previousP.ParameterOnC(),
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  // Indiquer que fin sur Bound.
 	}
 	else {
@@ -244,7 +235,7 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 	MakeExtremity(Exts,Index,solrst(1),Isvtx,Vtx);
 //	Extc.SetValue(previousP.PointOnC(),sol(3),tolesp);
 	Extc.SetValue(previousP.PointOnC(),previousP.ParameterOnC(),
-		      previousP.Parameter(),tolesp);
+                      previousP.Parameter(), my3DTolEsp);
 	Arrive = Standard_True;
       }
       break;
@@ -259,9 +250,9 @@ void Blend_CSWalking::InternalPerform(Blend_CSFunction& Func,
 */
 	previousP.ParametersOnS(U,V);
 	Exts.SetValue(previousP.PointOnS(),U,V,
-		      previousP.Parameter(),tolesp);
+                      previousP.Parameter(), my3DTolEsp);
 	Extc.SetValue(previousP.PointOnC(),previousP.ParameterOnC(),
-		      previousP.Parameter(),tolesp);
+                      previousP.Parameter(), my3DTolEsp);
 	Arrive = Standard_True;
       }
       break;
diff --git a/src/Blend/Blend_Walking_1.gxx b/src/Blend/Blend_Walking_1.gxx
index 16373be..5803bd9 100644
--- a/src/Blend/Blend_Walking_1.gxx
+++ b/src/Blend/Blend_Walking_1.gxx
@@ -25,18 +25,18 @@ Blend_Walking::Blend_Walking(const TheSurface& Surf1,
        twistflag1(Standard_False),twistflag2(Standard_False)
 
 {
-  domain1 = Domain1;
-  domain2 = Domain2;
-  recdomain1 = Domain1;
-  recdomain2 = Domain2;
+  myDomain1 = Domain1;
+  myDomain2 = Domain2;
+  myRecDomain1 = Domain1;
+  myRecDomain2 = Domain2;
   hguide = HGuide;
 }
 
 void Blend_Walking::SetDomainsToRecadre(const Handle(TheTopolTool)& Domain1,
 					const Handle(TheTopolTool)& Domain2)
 {
-  recdomain1 = Domain1;
-  recdomain2 = Domain2;
+  myRecDomain1 = Domain1;
+  myRecDomain2 = Domain2;
 }
 
 void Blend_Walking::AddSingularPoint(const Blend_Point& P) 
@@ -64,7 +64,7 @@ void Blend_Walking::Perform(Blend_Function& Func,
 			    const Standard_Real MaxStep,
 			    const Standard_Real TolGuide,
 			    const math_Vector& ParDep,
-			    const Standard_Real Tolesp,
+			    const Standard_Real the3DTolEsp,
 			    const Standard_Real Fleche,
 			    const Standard_Boolean Appro)
 {
@@ -75,7 +75,7 @@ void Blend_Walking::Perform(Blend_Function& Func,
   Standard_Boolean doextremities = 1;
   if(line.IsNull()) line = new TheLine ();
   else {line->Clear();doextremities = 0;}
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
   fleche = Abs(Fleche);
   rebrou = Standard_False;
@@ -95,10 +95,10 @@ void Blend_Walking::Perform(Blend_Function& Func,
   if (Appro) {
 
     TopAbs_State situ1,situ2;
-    math_Vector tolerance(1,4),infbound(1,4),supbound(1,4);
-    Func.GetTolerance(tolerance,tolesp);
+    math_Vector aVTol2D(1,4),infbound(1,4),supbound(1,4);
+    Func.GetTolerance(aVTol2D, my3DTolEsp);
     Func.GetBounds(infbound,supbound);
-    math_FunctionSetRoot rsnld(Func,tolerance,30);
+    math_FunctionSetRoot rsnld(Func,aVTol2D,30);
 
     rsnld.Perform(Func,ParDep,infbound,supbound);
     
@@ -107,12 +107,22 @@ void Blend_Walking::Perform(Blend_Function& Func,
     }
     rsnld.Root(sol);
 
-    if(clasonS1) situ1 = domain1->Classify(gp_Pnt2d(sol(1),sol(2)),
-					   Min(tolerance(1),tolerance(2)),0);
-    else situ1 = TopAbs_IN;
-    if(clasonS2) situ2 = domain2->Classify(gp_Pnt2d(sol(3),sol(4)),
-					   Min(tolerance(3),tolerance(4)),0);
-    else situ2 = TopAbs_IN;
+    if (clasonS1)
+    {
+      situ1 = myDomain1->Classify(gp_Pnt2d(sol(1), sol(2)), my3DTolEsp, Standard_False);
+    }
+    else
+    {
+      situ1 = TopAbs_IN;
+    }
+    if (clasonS2)
+    {
+      situ2 = myDomain2->Classify(gp_Pnt2d(sol(3), sol(4)), my3DTolEsp, Standard_False);
+    }
+    else
+    {
+      situ2 = TopAbs_IN;
+    }
 
     if (situ1 != TopAbs_IN || situ2 != TopAbs_IN) {
       return;
@@ -143,9 +153,9 @@ void Blend_Walking::Perform(Blend_Function& Func,
 
   if(doextremities){
     TheExtremity ptf1 (previousP.PointOnS1(),
-		       sol(1),sol(2),tolesp);
+                       sol(1),sol(2), my3DTolEsp);
     TheExtremity ptf2 (previousP.PointOnS2(),
-		       sol(3),sol(4),tolesp);
+                       sol(3), sol(4), my3DTolEsp);
     if (!previousP.IsTangencyPoint()) {
       ptf1.SetTangent(previousP.TangentOnS1());
       ptf2.SetTangent(previousP.TangentOnS2());
@@ -168,7 +178,7 @@ void Blend_Walking::Perform(Blend_Function& Func,
 Standard_Boolean Blend_Walking::PerformFirstSection(Blend_Function&     Func,
                                                     const Standard_Real Pdep,
                                                     math_Vector&        ParDep,
-                                                    const Standard_Real Tolesp,
+                                                    const Standard_Real the3DTolEsp,
                                                     const Standard_Real TolGuide,
                                                     TopAbs_State&       Pos1,
                                                     TopAbs_State&       Pos2)
@@ -176,7 +186,7 @@ Standard_Boolean Blend_Walking::PerformFirstSection(Blend_Function&     Func,
   iscomplete = Standard_False;
   comptra = Standard_False;
   line = new TheLine ();
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
 
   Pos1 = Pos2 = TopAbs_UNKNOWN;
@@ -184,10 +194,10 @@ Standard_Boolean Blend_Walking::PerformFirstSection(Blend_Function&     Func,
   param = Pdep;
   Func.Set(param);
 
-  math_Vector tolerance(1, 4),infbound(1, 4),supbound(1, 4);
-  Func.GetTolerance(tolerance, tolesp);
+  math_Vector aVTol2D(1, 4),infbound(1, 4),supbound(1, 4);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   Func.GetBounds(infbound, supbound);
-  math_FunctionSetRoot rsnld(Func, tolerance, 30);
+  math_FunctionSetRoot rsnld(Func, aVTol2D, 30);
 
   rsnld.Perform(Func, ParDep, infbound, supbound);
 
@@ -197,8 +207,10 @@ Standard_Boolean Blend_Walking::PerformFirstSection(Blend_Function&     Func,
   }
   rsnld.Root(sol);
   ParDep = sol;
-  Pos1 = domain1->Classify(gp_Pnt2d(sol(1), sol(2)), Min(tolerance(1), tolerance(2)), 0);
-  Pos2 = domain2->Classify(gp_Pnt2d(sol(3), sol(4)), Min(tolerance(3), tolerance(4)), 0);
+  {
+    Pos1 = myDomain1->Classify(gp_Pnt2d(sol(1), sol(2)), my3DTolEsp, Standard_False);
+    Pos2 = myDomain2->Classify(gp_Pnt2d(sol(3), sol(4)), my3DTolEsp, Standard_False);
+  }
   if (Pos1 != TopAbs_IN || Pos2 != TopAbs_IN)
   {
     return Standard_False;
@@ -220,7 +232,7 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
                                                      const Standard_Real Pdep,
                                                      const Standard_Real Pmax,
                                                      const math_Vector& ParDep,
-                                                     const Standard_Real Tolesp,
+                                                     const Standard_Real the3DTolEsp,
                                                      const Standard_Real TolGuide,
                                                      const Standard_Boolean RecOnS1,
                                                      const Standard_Boolean RecOnS2,
@@ -235,7 +247,7 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
   Standard_Real w1, w2, extrapol;
   Standard_Boolean recad1, recad2;
 
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
   if (Pmax - Pdep >= 0.0)
   {
@@ -252,7 +264,7 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
   param = Pdep;
   Func.Set(param);
 
-  math_Vector tolerance(1, 4),infbound(1, 4),supbound(1, 4);
+  math_Vector aVTol2D(1, 4),infbound(1, 4),supbound(1, 4);
   math_Vector solrst1(1, 4),solrst2(1, 4);
   TheExtremity Ext1, Ext2;
   Standard_Integer Index1 = 0, Index2 = 0, nbarc;
@@ -262,9 +274,9 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
   Standard_Real CorrectedU = 0., CorrectedV = 0.;
   gp_Pnt CorrectedPnt;
 
-  Func.GetTolerance(tolerance, tolesp);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   Func.GetBounds(infbound, supbound);
-  math_FunctionSetRoot rsnld(Func, tolerance, 30);
+  math_FunctionSetRoot rsnld(Func, aVTol2D, 30);
 
   rsnld.Perform(Func, ParDep, infbound, supbound);
 
@@ -313,14 +325,14 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
       State = Blend_OnRst1;
       param = w1;
       
-      recdomain1->Init();
+      myRecDomain1->Init();
       nbarc = 1;
       while (nbarc < Index1)
       {
         nbarc++;
-        recdomain1->Next();
+        myRecDomain1->Next();
       }
-      p2d = TheArcTool::Value(recdomain1->Value(), solrst1(1));
+      p2d = TheArcTool::Value(myRecDomain1->Value(), solrst1(1));
       ParSol(1) = p2d.X();
       ParSol(2) = p2d.Y();
       ParSol(3) = solrst1(3);
@@ -333,14 +345,14 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
       State = Blend_OnRst2;
       param = w2;
       
-      recdomain2->Init();
+      myRecDomain2->Init();
       nbarc = 1;
       while (nbarc < Index2)
       {
         nbarc++;
-        recdomain2->Next();
+        myRecDomain2->Next();
       }
-      p2d = TheArcTool::Value(recdomain2->Value(), solrst2(1));
+      p2d = TheArcTool::Value(myRecDomain2->Value(), solrst2(1));
       ParSol(1) = solrst2(3);
       ParSol(2) = solrst2(4);
       ParSol(3) = p2d.X();
@@ -352,14 +364,14 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
     // sol sur 1
     State = Blend_OnRst1;
     param = w1;
-    recdomain1->Init();
+    myRecDomain1->Init();
     nbarc = 1;
     while (nbarc < Index1)
     {
       nbarc++;
-      recdomain1->Next();
+      myRecDomain1->Next();
     }
-    p2d = TheArcTool::Value(recdomain1->Value(), solrst1(1));
+    p2d = TheArcTool::Value(myRecDomain1->Value(), solrst1(1));
     ParSol(1) = p2d.X();
     ParSol(2) = p2d.Y();
     ParSol(3) = solrst1(3);
@@ -375,14 +387,14 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
     State = Blend_OnRst2;
     param = w2;
     
-    recdomain2->Init();
+    myRecDomain2->Init();
     nbarc = 1;
     while (nbarc < Index2)
     {
       nbarc++;
-      recdomain2->Next();
+      myRecDomain2->Next();
     }
-    p2d = TheArcTool::Value(recdomain2->Value(), solrst2(1));
+    p2d = TheArcTool::Value(myRecDomain2->Value(), solrst2(1));
     ParSol(1) = solrst2(3);
     ParSol(2) = solrst2(4);
     ParSol(3) = p2d.X();
@@ -409,9 +421,9 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
 #endif
       MakeExtremity(Ext1, Standard_True, Index1, solrst1(1), Isvtx1, Vtx1);
       if (ToCorrectOnRst1)
-        Ext2.SetValue(CorrectedPnt, CorrectedU, CorrectedV, tolesp);
+        Ext2.SetValue(CorrectedPnt, CorrectedU, CorrectedV, my3DTolEsp);
       else
-        Ext2.SetValue(previousP.PointOnS2(), sol(3), sol(4), tolesp);
+        Ext2.SetValue(previousP.PointOnS2(), sol(3), sol(4), my3DTolEsp);
     }
     break;
 
@@ -424,9 +436,9 @@ Standard_Boolean Blend_Walking::PerformFirstSection (Blend_Function& Func,
       }
 #endif
       if (ToCorrectOnRst2)
-        Ext1.SetValue(CorrectedPnt, CorrectedU, CorrectedV, tolesp);
+        Ext1.SetValue(CorrectedPnt, CorrectedU, CorrectedV, my3DTolEsp);
       else
-        Ext1.SetValue(previousP.PointOnS1(), sol(1), sol(2), tolesp);
+        Ext1.SetValue(previousP.PointOnS1(), sol(1), sol(2), my3DTolEsp);
       MakeExtremity(Ext2, Standard_False, Index2, solrst2(1), Isvtx2, Vtx2);
     }
     break;
